<copyright> tdbc manager class.
    Written by <a href="mailto:yacc@gerbil.org">Andreas Kostyrka</a>

    Copyright &copy; 1998 Andreas Kostyrka

    This file is part of tdbc.  tdbc is distributed under the terms of
    the GNU Library General Public License, a copy of which can be found
    in the tdbc distribution; see the file COPYING.LIB.

    <id>$Id: Manager.t,v 1.3 2000/01/25 19:46:22 tiggr Exp $</id>
    </copyright>

implementation class
Manager: instance (All)
{
  static MutableObjectArray drivers;
}

<doc> Returns nil if the db could not be connected, or the connection
    object.  </doc>
Connection
   connect String url
      name String name
  password String password
{
  if (drivers == nil)
    drivers = [MutableObjectArray new];
  int i, n = [drivers length];
  for (i = 0; i < n; i++)
    if ([drivers[i] urlOk url])
      return [drivers[i] connect url name name password password];
}

<doc> DB drivers should call this to register themselves.  </doc>
void
  addDriver Driver driver
{
  if (drivers == nil)
    drivers = [MutableObjectArray new];
  [drivers add driver];
}

end;

implementation instance
Manager: instance (All)
end;

implementation class
Driver: instance (All)

end;

implementation instance
Driver: instance (All)

deferred boolean
  urlOk String url;

deferred Connection
   connect String url
      name String name
  password String password;

end;

implementation class
Connection: Cursor

end;

implementation instance
Connection

deferred void 
  close;

deferred void
  commit;

deferred void
  rollback;

<doc> Return {nil} if Cursors are not supported by the DB driver.  </doc>
deferred Cursor
  cursor;

end;

implementation class
Cursor: State

end;

implementation instance
Cursor
{
  public ObjectArray description;
}

deferred void 
  close;

<doc> If the command is a DML (data modification language) statement, then
    the return value is the number of affected rows.  </doc>
deferred int
  execute String sqlcommand;

<doc> Check if the driver supports this. The current do not.  </doc>
deferred int
  execute String sqlcommand
     with dynamic parameters;

<doc> Return an {ObjectArray} containing the row, or nil.  The returning
    fields may be either Strings or special DBI datatypes representing
    types like DATE, etc.  </doc>
deferred ObjectArray
  fetchone;

<doc> Return an {ObjectArray} of {ObjectArray}s each containing a row.
    </doc>
deferred ObjectArray
  fetchmany int size;

deferred ObjectArray
  fetchall;

end;

implementation class
Description: State

end;

implementation instance
Description
{
  public String name;
  public int typecode;
  public boolean nullok;
  public boolean isString;
}

id (self)
  init (String, int, boolean, boolean) (n, tc, no, is)
{
  name = n;
  typecode = tc;
  nullok = no;
  isString = is;
}

end;
